---
title: Pixel manipulation with canvas
slug: Web/API/Canvas_API/Tutorial/Pixel_manipulation_with_canvas
tags:
  - Canvas
  - Graphics
  - Intermediate
  - Tutorial
---
<div>{{CanvasSidebar}} {{PreviousNext("Web/API/Canvas_API/Tutorial/Advanced_animations", "Web/API/Canvas_API/Tutorial/Hit_regions_and_accessibility")}}</div>

<div class="summary">
<p>Until now we haven't looked at the actual pixels of our canvas. With the <code>ImageData</code> object you can directly read and write a data array to manipulate pixel data. We will also look into how image smoothing (anti-aliasing) can be controlled and how to save images from your canvas.</p>
</div>

<h2 id="The_ImageData_object">The ImageData object</h2>

<p>The {{domxref("ImageData")}} object represents the underlying pixel data of an area of a canvas object. It contains the following read-only attributes:</p>

<dl>
 <dt><code>width</code></dt>
 <dd>The width of the image in pixels.</dd>
 <dt><code>height</code></dt>
 <dd>The height of the image in pixels.</dd>
 <dt><code>data</code></dt>
 <dd>A {{jsxref("Uint8ClampedArray")}} representing a one-dimensional array containing the data in the RGBA order, with integer values between <code>0</code> and <code>255</code> (included).</dd>
</dl>

<p>The <code>data</code> property returns a {{jsxref("Uint8ClampedArray")}} which can be accessed to look at the raw pixel data; each pixel is represented by four one-byte values (red, green, blue, and alpha, in that order; that is, "RGBA" format). Each color component is represented by an integer between 0 and 255. Each component is assigned a consecutive index within the array, with the top left pixel's red component being at index 0 within the array. Pixels then proceed from left to right, then downward, throughout the array.</p>

<p>The {{jsxref("Uint8ClampedArray")}} contains <code>height</code> × <code>width</code> × 4 bytes of data, with index values ranging from 0 to (<code>height</code>×<code>width</code>×4)-1.</p>

<p>For example, to read the blue component's value from the pixel at column 200, row 50 in the image, you would do the following:</p>

<pre class="brush: js notranslate">blueComponent = imageData.data[((50 * (imageData.width * 4)) + (200 * 4)) + 2];</pre>

<p>If given a set of coordinates (X and Y), you may end up doing something like this:</p>

<pre class="brush: js notranslate">var xCoord = 50;
var yCoord = 100;
var canvasWidth = 1024;

function getColorIndicesForCoord(x, y, width) {
  var red = y * (width * 4) + x * 4;
  return [red, red + 1, red + 2, red + 3];
}

var colorIndices = getColorIndicesForCoord(xCoord, yCoord, canvasWidth);

var redIndex = colorIndices[0];
var greenIndex = colorIndices[1];
var blueIndex = colorIndices[2];
var alphaIndex = colorIndices[3];

var redForCoord = imageData.data[redIndex];
var greenForCoord = imageData.data[greenIndex];
var blueForCoord = imageData.data[blueIndex];
var alphaForCoord = imageData.data[alphaIndex];
</pre>

<p>Or, if ES2015 is appropriate:</p>

<pre class="brush: js notranslate">const xCoord = 50;
const yCoord = 100;
const canvasWidth = 1024;

const getColorIndicesForCoord = (x, y, width) =&gt; {
  const red = y * (width * 4) + x * 4;
  return [red, red + 1, red + 2, red + 3];
};

const colorIndices = getColorIndicesForCoord(xCoord, yCoord, canvasWidth);

const [redIndex, greenIndex, blueIndex, alphaIndex] = colorIndices;
</pre>

<p>You may also access the size of the pixel array in bytes by reading the <code>Uint8ClampedArray.length</code> attribute:</p>

<pre class="brush: js notranslate">var numBytes = imageData.data.length;
</pre>

<h2 id="Creating_an_ImageData_object">Creating an ImageData object</h2>

<p>To create a new, blank <code>ImageData</code> object, you should use the {{domxref("CanvasRenderingContext2D.createImageData", "createImageData()")}} method. There are two versions of the <code>createImageData()</code> method:</p>

<pre class="brush: js notranslate">var myImageData = ctx.createImageData(width, height);</pre>

<p>This creates a new <code>ImageData</code> object with the specified dimensions. All pixels are preset to transparent black (all zeroes i.e rgba(0,0,0,0)).</p>

<p>You can also create a new <code>ImageData</code> object with the same dimensions as the object specified by <code>anotherImageData</code>. The new object's pixels are all preset to transparent black. <strong>This does not copy the image data!</strong></p>

<pre class="brush: js notranslate">var myImageData = ctx.createImageData(anotherImageData);</pre>

<h2 id="Getting_the_pixel_data_for_a_context">Getting the pixel data for a context</h2>

<p>To obtain an <code>ImageData</code> object containing a copy of the pixel data for a canvas context, you can use the <code>getImageData()</code> method:</p>

<pre class="brush: js notranslate">var myImageData = ctx.getImageData(left, top, width, height);</pre>

<p>This method returns an <code>ImageData</code> object representing the pixel data for the area of the canvas whose corners are represented by the points (<code>left</code>,<code>top</code>), (<code>left+width</code>, <code>top</code>), (<code>left</code>, <code>top+height</code>), and (<code>left+width</code>, <code>top+height</code>). The coordinates are specified in canvas coordinate space units.</p>

<div class="note">
<p><strong>Note</strong>: Any pixels outside the canvas are returned as transparent black in the resulting <code>ImageData</code> object.</p>
</div>

<p>This method is also demonstrated in the article <a href="/en-US/docs/Web/API/Canvas_API/Manipulating_video_using_canvas">Manipulating video using canvas</a>.</p>

<h3 id="A_color_picker">A color picker</h3>

<p>In this example we are using the <a href="/en-US/docs/Web/API/CanvasRenderingContext2D/getImageData"><code>getImageData()</code> </a>method to display the color under the mouse cursor. For this, we need the current position of the mouse with <code>layerX</code> and <code>layerY</code>, then we look up the pixel data on that position in the pixel array that <code><a href="/en-US/docs/Web/API/CanvasRenderingContext2D/getImageData">getImageData()</a></code> provides us. Finally, we use the array data to set a background color and a text in the <code>&lt;div&gt;</code> to display the color. Clicking on the image will do the same operation but remember what the selected color was.</p>

<pre class="brush: js; notranslate">var img = new Image();
img.crossOrigin = 'anonymous';
img.src = './assets/rhino.jpg';
var canvas = document.getElementById('canvas');
var ctx = canvas.getContext('2d');
img.onload = function() {
  ctx.drawImage(img, 0, 0);
  img.style.display = 'none';
};
var hoveredColor = document.getElementById('hovered-color');
var selectedColor = document.getElementById('selected-color');

function pick(event, destination) {
  var x = event.layerX;
  var y = event.layerY;
  var pixel = ctx.getImageData(x, y, 1, 1);
  var data = pixel.data;

    const rgba = `rgba(${data[0]}, ${data[1]}, ${data[2]}, ${data[3] / 255})`;
    destination.style.background = rgba;
    destination.textContent = rgba;

    return rgba;
}

canvas.addEventListener('mousemove', function(event) {
    pick(event, hoveredColor);
});
canvas.addEventListener('click', function(event) {
    pick(event, selectedColor);
});
</pre>

<p>The code's usage is demonstrated in the following live example:</p>

<p>{{EmbedGHLiveSample("dom-examples/canvas/pixel-manipulation/color-picker.html", '100%', 300)}}</p>

<p>Also see the source code — <a href="https://github.com/mdn/dom-examples/blob/master/canvas/pixel-manipulation/color-picker.html">HTML</a>, <a href="https://github.com/mdn/dom-examples/blob/master/canvas/pixel-manipulation/color-picker.js">JavaScript</a>.</p>

<h2 id="Painting_pixel_data_into_a_context">Painting pixel data into a context</h2>

<p>You can use the<a href="/en-US/docs/Web/API/CanvasRenderingContext2D/putImageData"> putImageData() </a>method to paint pixel data into a context:</p>

<pre class="brush: js notranslate">ctx.putImageData(myImageData, dx, dy);
</pre>

<p>The <code>dx</code> and <code>dy</code> parameters indicate the device coordinates within the context at which to paint the top left corner of the pixel data you wish to draw.</p>

<p>For example, to paint the entire image represented by <code>myImageData</code> to the top left corner of the context, you can do the following:</p>

<pre class="brush: js notranslate">ctx.putImageData(myImageData, 0, 0);
</pre>

<h3 id="Grayscaling_and_inverting_colors">Grayscaling and inverting colors</h3>

<p>In this example we iterate over all pixels to change their values, then we put the modified pixel array back to the canvas using <a href="/en-US/docs/Web/API/CanvasRenderingContext2D/putImageData">putImageData()</a>. The invert function subtracts each color from the max value 255. The grayscale function uses the average of red, green and blue. You can also use a weighted average, given by the formula <code>x = 0.299r + 0.587g + 0.114b</code>, for example. See <a href="http://en.wikipedia.org/wiki/Grayscale">Grayscale</a> on Wikipedia for more information.</p>

<pre class="brush: js notranslate">var img = new Image();
img.crossOrigin = 'anonymous';
img.src = './assets/rhino.jpg';

var canvas = document.getElementById('canvas');
var ctx = canvas.getContext('2d');

img.onload = function() {
    ctx.drawImage(img, 0, 0);
};

var original = function() {
    ctx.drawImage(img, 0, 0);
};

var invert = function() {
    ctx.drawImage(img, 0, 0);
    const imageData = ctx.getImageData(0, 0, canvas.width, canvas.height);
    const data = imageData.data;
    for (var i = 0; i &lt; data.length; i += 4) {
        data[i]     = 255 - data[i];     // red
        data[i + 1] = 255 - data[i + 1]; // green
        data[i + 2] = 255 - data[i + 2]; // blue
    }
    ctx.putImageData(imageData, 0, 0);
};

var grayscale = function() {
    ctx.drawImage(img, 0, 0);
    const imageData = ctx.getImageData(0, 0, canvas.width, canvas.height);
    const data = imageData.data;
    for (var i = 0; i &lt; data.length; i += 4) {
        var avg = (data[i] + data[i + 1] + data[i + 2]) / 3;
        data[i]     = avg; // red
        data[i + 1] = avg; // green
        data[i + 2] = avg; // blue
    }
    ctx.putImageData(imageData, 0, 0);
};

const inputs = document.querySelectorAll('[name=color]');
for (const input of inputs) {
    input.addEventListener("change", function(evt) {
        switch (evt.target.value) {
            case "inverted":
                return invert();
            case "grayscale":
                return grayscale();
            default:
                return original();
        }
    });
}
</pre>

<p>The code's usage is demonstrated in the following live example:</p>

<p>{{EmbedGHLiveSample("dom-examples/canvas/pixel-manipulation/color-manipulation.html", '100%', 300)}}</p>

<p>Also see the source code — <a href="https://github.com/mdn/dom-examples/blob/master/canvas/pixel-manipulation/color-manipulation.html">HTML</a>, <a href="https://github.com/mdn/dom-examples/blob/master/canvas/pixel-manipulation/color-manipulation.js">JavaScript</a>.</p>

<h2 id="Zooming_and_anti-aliasing">Zooming and anti-aliasing</h2>

<p>With the help of the {{domxref("CanvasRenderingContext2D.drawImage", "drawImage()")}} method, a second canvas and the {{domxref("CanvasRenderingContext2D.imageSmoothingEnabled", "imageSmoothingEnabled")}} property, we are able to zoom into our picture and see the details. A third canvas without {{domxref("CanvasRenderingContext2D.imageSmoothingEnabled", "imageSmoothingEnabled")}} is also drawn onto to be able to have a side by side comparison </p>

<p>We get the position of the mouse and crop an image of 5 pixels left and above to 5 pixels right and below. Then we copy that one over to another canvas and resize the image to the size we want it to. In the zoom canvas we resize a 10×10 pixel crop of the original canvas to 200×200.</p>

<pre class="brush: js notranslate">zoomctx.drawImage(canvas,
                  Math.min(Math.max(0, x - 5), img.width - 10),
                  Math.min(Math.max(0, y - 5), img.height - 10),
                  10, 10, 0, 0, 200, 200);</pre>

<p>Zoom example:</p>

<pre class="brush: js notranslate">var img = new Image();
img.crossOrigin = 'anonymous';
img.src = './assets/rhino.jpg';
img.onload = function() {
  draw(this);
};

function draw(img) {
  var canvas = document.getElementById('canvas');
  var ctx = canvas.getContext('2d');
  ctx.drawImage(img, 0, 0);

  var smoothedZoomCtx = document.getElementById('smoothed-zoom').getContext('2d');
  smoothedZoomCtx.imageSmoothingEnabled = true;
  smoothedZoomCtx.mozImageSmoothingEnabled = true;
  smoothedZoomCtx.webkitImageSmoothingEnabled = true;
  smoothedZoomCtx.msImageSmoothingEnabled = true;

  var pixelatedZoomCtx = document.getElementById('pixelated-zoom').getContext('2d');
  pixelatedZoomCtx.imageSmoothingEnabled = false;
  pixelatedZoomCtx.mozImageSmoothingEnabled = false;
  pixelatedZoomCtx.webkitImageSmoothingEnabled = false;
  pixelatedZoomCtx.msImageSmoothingEnabled = false;

  var zoom = function(ctx, x, y) {
    ctx.drawImage(canvas,
        Math.min(Math.max(0, x - 5), img.width - 10),
        Math.min(Math.max(0, y - 5), img.height - 10),
        10, 10,
        0, 0,
        200, 200);
  };

  canvas.addEventListener('mousemove', function(event) {
    const x = event.layerX;
    const y = event.layerY;
    zoom(smoothedZoomCtx, x, y);
    zoom(pixelatedZoomCtx, x, y);
  });
}</pre>

<p>The code's usage is demonstrated in the following live example:</p>

<p>{{EmbedGHLiveSample("dom-examples/canvas/pixel-manipulation/image-smoothing.html", '100%', 300)}}</p>

<p>Also see the source code — <a href="https://github.com/mdn/dom-examples/blob/master/canvas/pixel-manipulation/image-smoothing.html">HTML</a>, <a href="https://github.com/mdn/dom-examples/blob/master/canvas/pixel-manipulation/image-smoothing.js">JavaScript</a>.</p>

<h2 id="Saving_images">Saving images</h2>

<p>The {{domxref("HTMLCanvasElement")}} provides a <code>toDataURL()</code> method, which is useful when saving images. It returns a <a href="/en-US/docs/Web/HTTP/data_URIs">data URI</a> containing a representation of the image in the format specified by the <code>type</code> parameter (defaults to <a class="external external-icon" href="https://en.wikipedia.org/wiki/Portable_Network_Graphics">PNG</a>). The returned image is in a resolution of 96 dpi.</p>

<p><strong>Note:</strong> Be aware that if the canvas contains any pixels that were obtained from another {{Glossary("origin")}} without using CORS, the canvas is <strong>tainted</strong> and its contents can no longer be read and saved. See {{SectionOnPage("/en-US/docs/Web/HTML/CORS_enabled_image", "Security and tainted canvases")}}</p>

<dl>
 <dt>{{domxref("HTMLCanvasElement.toDataURL", "canvas.toDataURL('image/png')")}}</dt>
 <dd>Default setting. Creates a PNG image.</dd>
 <dt>{{domxref("HTMLCanvasElement.toDataURL", "canvas.toDataURL('image/jpeg', quality)")}}</dt>
 <dd>Creates a JPG image. Optionally, you can provide a quality in the range from 0 to 1, with one being the best quality and with 0 almost not recognizable but small in file size.</dd>
</dl>

<p>Once you have generated a data URI from you canvas, you are able to use it as the source of any {{HTMLElement("image")}} or put it into a hyper link with a <a href="/en-US/docs/Web/HTML/Element/a#attr-download">download attribute</a> to save it to disc, for example.</p>

<p>You can also create a {{domxref("Blob")}} from the canvas.</p>

<dl>
 <dt>{{domxref("HTMLCanvasElement.toBlob", "canvas.toBlob(<em>callback</em>, <em>type</em>, <em>encoderOptions</em>)")}}</dt>
 <dd>Creates a <code>Blob</code> object representing the image contained in the canvas.</dd>
</dl>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("ImageData")}}</li>
 <li><a href="/en-US/docs/Web/API/Canvas_API/Manipulating_video_using_canvas">Manipulating video using canvas</a></li>
 <li><a href="https://codepo8.github.io/canvas-images-and-pixels/">Canvas, images and pixels – by Christian Heilmann</a></li>
</ul>

<p>{{PreviousNext("Web/API/Canvas_API/Tutorial/Advanced_animations", "Web/API/Canvas_API/Tutorial/Hit_regions_and_accessibility")}}</p>
